Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerAdvancedWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerAdvancedWidget.cpp	(revision 107298)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerAdvancedWidget.cpp	(revision 107299)
@@ -763,7 +763,7 @@
 
         /* Create Global Tools-menu: */
-        m_pMenuToolsGlobal = new UITools(UIToolClass_Global, this);
+        m_pMenuToolsGlobal = new UITools(this, UIToolClass_Global, actionPool());
         /* Create Machine Tools-menu: */
-        m_pMenuToolsMachine = new UITools(UIToolClass_Machine, this);
+        m_pMenuToolsMachine = new UITools(this, UIToolClass_Machine, actionPool());
     }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 107298)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 107299)
@@ -804,7 +804,7 @@
 
         /* Create Global Tools-menu: */
-        m_pMenuToolsGlobal = new UITools(UIToolClass_Global, this);
+        m_pMenuToolsGlobal = new UITools(this, UIToolClass_Global, actionPool());
         /* Create Machine Tools-menu: */
-        m_pMenuToolsMachine = new UITools(UIToolClass_Machine, this);
+        m_pMenuToolsMachine = new UITools(this, UIToolClass_Machine, actionPool());
     }
 
@@ -866,4 +866,6 @@
     connect(m_pPaneChooser, &UIChooser::sigMachineSearchWidgetVisibilityChanged,
             this, &UIVirtualBoxManagerWidget::sigMachineSearchWidgetVisibilityChanged);
+    connect(this, &UIVirtualBoxManagerWidget::sigToolBarHeightChange,
+            m_pPaneChooser, &UIChooser::setGlobalItemHeightHint);
 
     /* Details-pane connections: */
@@ -1121,4 +1123,6 @@
     disconnect(m_pPaneChooser, &UIChooser::sigMachineSearchWidgetVisibilityChanged,
                this, &UIVirtualBoxManagerWidget::sigMachineSearchWidgetVisibilityChanged);
+    disconnect(this, &UIVirtualBoxManagerWidget::sigToolBarHeightChange,
+               m_pPaneChooser, &UIChooser::setGlobalItemHeightHint);
 
     /* Details-pane connections: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp	(revision 107298)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp	(revision 107299)
@@ -33,15 +33,9 @@
 #include "UIChooserModel.h"
 #include "UIChooserView.h"
-#ifndef VBOX_GUI_WITH_ADVANCED_WIDGETS
-# include "UIVirtualBoxManagerWidget.h"
-#else
-# include "UIVirtualBoxManagerAdvancedWidget.h"
-#endif
 #include "UIVirtualMachineItem.h"
 
 
-UIChooser::UIChooser(UIVirtualBoxManagerWidget *pParent, UIActionPool *pActionPool)
+UIChooser::UIChooser(QWidget *pParent, UIActionPool *pActionPool)
     : QWidget(pParent)
-    , m_pParent(pParent)
     , m_pActionPool(pActionPool)
     , m_pChooserModel(0)
@@ -283,8 +277,4 @@
     AssertPtrReturnVoid(model());
     AssertPtrReturnVoid(view());
-
-    /* Parent connections: */
-    connect(m_pParent, &UIVirtualBoxManagerWidget::sigToolBarHeightChange,
-            this, &UIChooser::setGlobalItemHeightHint);
 
     /* Abstract Chooser-model connections: */
@@ -369,8 +359,4 @@
     disconnect(view(), &UIChooserView::sigSearchWidgetVisibilityChanged,
                this, &UIChooser::sigMachineSearchWidgetVisibilityChanged);
-
-    /* Parent connections: */
-    disconnect(m_pParent, &UIVirtualBoxManagerWidget::sigToolBarHeightChange,
-               this, &UIChooser::setGlobalItemHeightHint);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h	(revision 107298)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h	(revision 107299)
@@ -37,5 +37,4 @@
 /* GUI includes: */
 #include "UIExtraDataDefs.h"
-#include "UIManagerDefs.h"
 
 /* Forward declarations: */
@@ -44,5 +43,4 @@
 class UIChooserView;
 class UIVirtualMachineItem;
-class UIVirtualBoxManagerWidget;
 class UIVirtualMachineItemCloud;
 
@@ -106,5 +104,5 @@
     /** Constructs Chooser-pane passing @a pParent to the base-class.
       * @param  pActionPool  Brings the action-pool reference.  */
-    UIChooser(UIVirtualBoxManagerWidget *pParent, UIActionPool *pActionPool);
+    UIChooser(QWidget *pParent, UIActionPool *pActionPool);
     /** Destructs Chooser-pane. */
     virtual ~UIChooser() RT_OVERRIDE;
@@ -239,7 +237,4 @@
     /** @name General stuff.
       * @{ */
-        /** Holds the parent reference. */
-        UIVirtualBoxManagerWidget *m_pParent;
-
         /** Holds the action-pool reference. */
         UIActionPool *m_pActionPool;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.cpp	(revision 107298)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.cpp	(revision 107299)
@@ -33,9 +33,4 @@
 #include "UIToolsModel.h"
 #include "UIToolsView.h"
-#ifndef VBOX_GUI_WITH_ADVANCED_WIDGETS
-# include "UIVirtualBoxManagerWidget.h"
-#else
-# include "UIVirtualBoxManagerAdvancedWidget.h"
-#endif
 
 /* Other VBox includes: */
@@ -43,8 +38,8 @@
 
 
-UITools::UITools(UIToolClass enmClass, UIVirtualBoxManagerWidget *pParent /* = 0 */)
+UITools::UITools(QWidget *pParent, UIToolClass enmClass, UIActionPool *pActionPool)
     : QWidget(pParent, Qt::Popup)
     , m_enmClass(enmClass)
-    , m_pManagerWidget(pParent)
+    , m_pActionPool(pActionPool)
     , m_pMainLayout(0)
     , m_pToolsModel(0)
@@ -56,5 +51,5 @@
 UIActionPool *UITools::actionPool() const
 {
-    return managerWidget()->actionPool();
+    return m_pActionPool;
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.h	(revision 107298)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.h	(revision 107299)
@@ -37,5 +37,4 @@
 /* GUI icludes: */
 #include "UIExtraDataDefs.h"
-#include "UIManagerDefs.h"
 
 /* Forward declarations: */
@@ -45,5 +44,4 @@
 class UIToolsModel;
 class UIToolsView;
-class UIVirtualBoxManagerWidget;
 
 /** QWidget extension used as VM Tools-pane. */
@@ -69,12 +67,10 @@
 
     /** Constructs Tools-pane passing @a pParent to the base-class.
-      * @param  Brings the tools class, it will be fixed one. */
-    UITools(UIToolClass enmClass, UIVirtualBoxManagerWidget *pParent = 0);
+      * @param  enmClass     Brings the tools class, it will be fixed one.
+      * @param  pActionPool  Brings the action-pool reference. */
+    UITools(QWidget *pParent, UIToolClass enmClass, UIActionPool *pActionPool);
 
     /** @name General stuff.
       * @{ */
-        /** Returns the manager-widget reference. */
-        UIVirtualBoxManagerWidget *managerWidget() const { return m_pManagerWidget; }
-
         /** Returns the action-pool reference. */
         UIActionPool *actionPool() const;
@@ -130,12 +126,12 @@
         const UIToolClass  m_enmClass;
 
-        /** Holds the manager-widget reference. */
-        UIVirtualBoxManagerWidget *m_pManagerWidget;
+        /** Holds the action-pool reference. */
+        UIActionPool *m_pActionPool;
 
-        /** Holds the main layout instane. */
+        /** Holds the main layout instance. */
         QVBoxLayout  *m_pMainLayout;
-        /** Holds the Tools-model instane. */
+        /** Holds the Tools-model instance. */
         UIToolsModel *m_pToolsModel;
-        /** Holds the Tools-view instane. */
+        /** Holds the Tools-view instance. */
         UIToolsView  *m_pToolsView;
     /** @} */