Index: trunk/src/VBox/Installer/win/NLS/de_DE.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/de_DE.wxl	(revision 107323)
+++ trunk/src/VBox/Installer/win/NLS/de_DE.wxl	(revision 107324)
@@ -65,4 +65,5 @@
     <!---->
 
+    <String Id="UsedByOtherApp" Value="Es wurde eine Anwendung erkannt, die die aktuell installierte VirtualBox-Version verwendet. Sie müssen diese Anwendung entfernen, bevor Sie mit der Installation fortfahren. Einzelheiten dazu finden Sie in der Datei dependency.dep im VirtualBox-Installationsverzeichnis." />
     <String Id="NeedAdmin" Value="Sie benötigen Administrations-Rechte zum (De-)Installieren von [ProductName]! Das Setup wird nun beendet." />
     <String Id="NeedMSCRT" Value="Für [ProductName] muss zuerst das Microsoft Visual C++ 2019 Redistributable Package installiert werden. Bitte installieren und danach die Installation von [ProductName] wiederholen." />
Index: trunk/src/VBox/Installer/win/NLS/el_GR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/el_GR.wxl	(revision 107323)
+++ trunk/src/VBox/Installer/win/NLS/el_GR.wxl	(revision 107324)
@@ -65,4 +65,5 @@
     <!---->
 
+    <String Id="UsedByOtherApp" Value="It was detected an application which has been using currently installed VirtualBox version. You must remove this application before continuing installation. See the file dependency.dep in the VirtualBox installation directory for details." />
     <String Id="NeedAdmin" Value="Πρέπει να έχετε δικαιώματα διαχειριστή για την (απ)εγκατάσταση του [ProductName]! Η εφαρμογή θα τερματιστεί τώρα." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
Index: trunk/src/VBox/Installer/win/NLS/en_US.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/en_US.wxl	(revision 107323)
+++ trunk/src/VBox/Installer/win/NLS/en_US.wxl	(revision 107324)
@@ -64,4 +64,5 @@
     <!---->
 
+    <String Id="UsedByOtherApp" Value="It was detected an application which has been using currently installed VirtualBox version. You must remove this application before continuing installation. See the file dependency.dep in the VirtualBox installation directory for details." />
     <String Id="NeedAdmin" Value="You need to have administrator rights to (un)install [ProductName]! This setup will abort now." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
Index: trunk/src/VBox/Installer/win/NLS/fa_IR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/fa_IR.wxl	(revision 107323)
+++ trunk/src/VBox/Installer/win/NLS/fa_IR.wxl	(revision 107324)
@@ -58,4 +58,5 @@
     <String Id="VB_Python" Value="پشتیبانی از پایتون برای ویرچوال باکس." />
     <!---->
+    <String Id="UsedByOtherApp" Value="It was detected an application which has been using currently installed VirtualBox version. You must remove this application before continuing installation. See the file dependency.dep in the VirtualBox installation directory for details." />
     <String Id="NeedAdmin" Value="برای حذف [ProductName] شما نیاز به اجازه مدیر دارید! این راه انداز حالا لغو میشود." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
Index: trunk/src/VBox/Installer/win/NLS/fr_FR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/fr_FR.wxl	(revision 107323)
+++ trunk/src/VBox/Installer/win/NLS/fr_FR.wxl	(revision 107324)
@@ -65,4 +65,5 @@
     <!---->
 
+    <String Id="UsedByOtherApp" Value="Il a été détecté une application qui utilise la version de VirtualBox actuellement installée. Vous devez supprimer cette application avant de poursuivre l'installation. Voir le fichier dependency.dep dans le répertoire d'installation de VirtualBox pour plus de détails." />
     <String Id="NeedAdmin" Value="Vous ne pouvez pas (dés)installer [ProductName] sans droits d'administrateur! Ce programme d'installation terminera maintenant." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
Index: trunk/src/VBox/Installer/win/NLS/it_IT.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/it_IT.wxl	(revision 107323)
+++ trunk/src/VBox/Installer/win/NLS/it_IT.wxl	(revision 107324)
@@ -58,4 +58,5 @@
     <String Id="VB_Python" Value="Supporto Python per VirtualBox." />
     <!---->
+    <String Id="UsedByOtherApp" Value="È stata rilevata un'applicazione che ha utilizzato la versione di VirtualBox attualmente installata. È necessario rimuovere questa applicazione prima di continuare l'installazione. Per i dettagli, consultare il file dependency.dep nella directory di installazione di VirtualBox." />
     <String Id="NeedAdmin" Value="Devi avere diritti di amministrazione per (dis)installare [ProductName]! L'installazione sarà interrotta immediatamente." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
Index: trunk/src/VBox/Installer/win/NLS/ru_RU.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/ru_RU.wxl	(revision 107323)
+++ trunk/src/VBox/Installer/win/NLS/ru_RU.wxl	(revision 107324)
@@ -65,4 +65,5 @@
     <!---->
 
+    <String Id="UsedByOtherApp" Value="It was detected an application which has been using currently installed VirtualBox version. You must remove this application before continuing installation. See the file dependency.dep in the VirtualBox installation directory for details." />
     <String Id="NeedAdmin" Value="You need to have administrator rights to (un)install [ProductName]! This setup will abort now." />
     <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
Index: trunk/src/VBox/Installer/win/NLS/tr_TR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/tr_TR.wxl	(revision 107323)
+++ trunk/src/VBox/Installer/win/NLS/tr_TR.wxl	(revision 107324)
@@ -65,4 +65,5 @@
     <!---->
 
+    <String Id="UsedByOtherApp" Value="Şu anda yüklü olan VirtualBox sürümünü kullanan bir uygulama tespit edildi. Kuruluma devam etmeden önce bu uygulamayı kaldırmalısınız. Ayrıntılar için VirtualBox kurulum dizinindeki dependency.dep dosyasına bakın." />
     <String Id="NeedAdmin" Value="[ProductName] uygulamasını yüklemek(kaldırmak) için yönetici haklarına sahip olmanız gerekir! Bu kur şimdi iptal edilecek." />
     <String Id="NeedMSCRT" Value="[ProductName] uygulamasının öncelikle Microsoft Visual C++ 2019 Yeniden Dağıtılabilir Paketinin yüklenmesine ihtiyacı var. Lütfen [ProductName] uygulamasının kurulumunu yeniden başlatın ve yükleyin." />
Index: trunk/src/VBox/Installer/win/NLS/zh_CN.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/zh_CN.wxl	(revision 107323)
+++ trunk/src/VBox/Installer/win/NLS/zh_CN.wxl	(revision 107324)
@@ -65,4 +65,5 @@
 <!---->
 
+<String Id="UsedByOtherApp" Value="检测到一个应用程序正在使用当前安装的 VirtualBox 版本。在继续安装之前，您必须删除该应用程序。有关详细信息，请参阅 VirtualBox 安装目录中的 dependency.dep 文件." />
 <String Id="NeedAdmin" Value="需要系统管理员权限安装 （或卸载）[ProductName]！此安装程序现在将中止。" />
 <String Id="NeedMSCRT" Value="[ProductName] needs the Microsoft Visual C++ 2019 Redistributable Package being installed first. Please install and restart the installation of [ProductName]." />
Index: trunk/src/VBox/Installer/win/NLS/zh_TW.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/zh_TW.wxl	(revision 107323)
+++ trunk/src/VBox/Installer/win/NLS/zh_TW.wxl	(revision 107324)
@@ -65,4 +65,5 @@
     <!---->
 
+    <String Id="UsedByOtherApp" Value="It was detected an application which has been using currently installed VirtualBox version. You must remove this application before continuing installation. See the file dependency.dep in the VirtualBox installation directory for details." />
     <String Id="NeedAdmin" Value="您需要有系統管理員特殊權限以安裝 （或解除安裝）[ProductName]！此安裝程式現在將中止。" />
     <String Id="NeedMSCRT" Value="[ProductName] 需要先安裝 Microsoft Visual C++ 2019 可分發套件。 請安裝並重新啟動 [ProductName] 安裝。" />
Index: trunk/src/VBox/Installer/win/VirtualBox.wxs
===================================================================
--- trunk/src/VBox/Installer/win/VirtualBox.wxs	(revision 107323)
+++ trunk/src/VBox/Installer/win/VirtualBox.wxs	(revision 107324)
@@ -193,8 +193,5 @@
     -->
 
-    <Launch Condition="NOT (VBOXDEPENDENCY AND UPGRADINGPRODUCTCODE)"
-            Message="It was detected an application which has been using currently installed VirtualBox version.
-                     You must remove this application before continuing installation.
-                     See the file dependency.dep in the VirtualBox installation directory for details. " />
+    <Launch Condition="NOT (VBOXDEPENDENCY AND UPGRADINGPRODUCTCODE)" Message="!(loc.UsedByOtherApp)" />
 
     <!-- Detect old Sun installation -->