Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.cpp	(revision 107330)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.cpp	(revision 107331)
@@ -242,4 +242,12 @@
 }
 
+void UIMachineManagerWidget::switchToVMActivityPane(const QUuid &uMachineId)
+{
+    AssertPtrReturnVoid(m_pPaneChooser);
+    AssertPtrReturnVoid(m_pMenuTools);
+    m_pPaneChooser->setCurrentMachine(uMachineId);
+    m_pMenuTools->setToolsType(UIToolType_VMActivity);
+}
+
 bool UIMachineManagerWidget::isCurrentStateItemSelected() const
 {
@@ -423,12 +431,4 @@
     // smaller size often being ignored until it is actually shown.
     pMenu->resize(ourGeo.size());
-}
-
-void UIMachineManagerWidget::sltSwitchToVMActivityPane(const QUuid &uMachineId)
-{
-    AssertPtrReturnVoid(m_pPaneChooser);
-    AssertPtrReturnVoid(m_pMenuTools);
-    m_pPaneChooser->setCurrentMachine(uMachineId);
-    m_pMenuTools->setToolsType(UIToolType_VMActivity);
 }
 
@@ -489,11 +489,6 @@
                     if (m_pPaneTools)
                     {
+                        /// @todo make sure it's used properly
                         m_pPaneTools->setActive(true);
-                        connect(m_pPaneTools, &UIToolPaneMachine::sigDetachToolPane,
-                                this, &UIMachineManagerWidget::sigDetachToolPane);
-                        connect(m_pPaneTools, &UIToolPaneMachine::sigCurrentSnapshotItemChange,
-                                this, &UIMachineManagerWidget::sigCurrentSnapshotItemChange);
-                        connect(m_pPaneTools, &UIToolPaneMachine::sigSwitchToActivityOverviewPane,
-                                this, &UIMachineManagerWidget::sigSwitchToActivityOverviewPane);
 
                         /* Add into layout: */
@@ -546,28 +541,18 @@
     connect(m_pPaneChooser, &UIChooser::sigSelectionInvalidated,
             this, &UIMachineManagerWidget::sltHandleChooserPaneSelectionInvalidated);
+    connect(m_pPaneChooser, &UIChooser::sigToolMenuRequested,
+            this, &UIMachineManagerWidget::sltHandleToolMenuRequested);
+    connect(m_pPaneChooser, &UIChooser::sigCloudMachineStateChange,
+            this, &UIMachineManagerWidget::sltHandleCloudMachineStateChange);
     connect(m_pPaneChooser, &UIChooser::sigToggleStarted,
             m_pPaneTools, &UIToolPaneMachine::sigToggleStarted);
     connect(m_pPaneChooser, &UIChooser::sigToggleFinished,
             m_pPaneTools, &UIToolPaneMachine::sigToggleFinished);
-    connect(m_pPaneChooser, &UIChooser::sigGroupSavingStateChanged,
-            this, &UIMachineManagerWidget::sigGroupSavingStateChanged);
-    connect(m_pPaneChooser, &UIChooser::sigCloudUpdateStateChanged,
-            this, &UIMachineManagerWidget::sigCloudUpdateStateChanged);
-    connect(m_pPaneChooser, &UIChooser::sigToolMenuRequested,
-            this, &UIMachineManagerWidget::sltHandleToolMenuRequested);
-    connect(m_pPaneChooser, &UIChooser::sigCloudProfileStateChange,
-            this, &UIMachineManagerWidget::sigCloudProfileStateChange);
-    connect(m_pPaneChooser, &UIChooser::sigCloudMachineStateChange,
-            this, &UIMachineManagerWidget::sltHandleCloudMachineStateChange);
-    connect(m_pPaneChooser, &UIChooser::sigStartOrShowRequest,
-            this, &UIMachineManagerWidget::sigStartOrShowRequest);
-    connect(m_pPaneChooser, &UIChooser::sigMachineSearchWidgetVisibilityChanged,
-            this, &UIMachineManagerWidget::sigMachineSearchWidgetVisibilityChanged);
-
-    /* Details-pane connections: */
+
+    /* Tools-pane connections: */
     connect(m_pPaneTools, &UIToolPaneMachine::sigLinkClicked,
             this, &UIMachineManagerWidget::sigMachineSettingsLinkClicked);
 
-    /* Tools-pane connections: */
+    /* Tools-menu connections: */
     connect(m_pMenuTools, &UITools::sigSelectionChanged,
             this, &UIMachineManagerWidget::sltHandleToolsMenuIndexChange);
@@ -601,28 +586,18 @@
     disconnect(m_pPaneChooser, &UIChooser::sigSelectionInvalidated,
                this, &UIMachineManagerWidget::sltHandleChooserPaneSelectionInvalidated);
+    disconnect(m_pPaneChooser, &UIChooser::sigToolMenuRequested,
+               this, &UIMachineManagerWidget::sltHandleToolMenuRequested);
+    disconnect(m_pPaneChooser, &UIChooser::sigCloudMachineStateChange,
+               this, &UIMachineManagerWidget::sltHandleCloudMachineStateChange);
     disconnect(m_pPaneChooser, &UIChooser::sigToggleStarted,
                m_pPaneTools, &UIToolPaneMachine::sigToggleStarted);
     disconnect(m_pPaneChooser, &UIChooser::sigToggleFinished,
                m_pPaneTools, &UIToolPaneMachine::sigToggleFinished);
-    disconnect(m_pPaneChooser, &UIChooser::sigGroupSavingStateChanged,
-               this, &UIMachineManagerWidget::sigGroupSavingStateChanged);
-    disconnect(m_pPaneChooser, &UIChooser::sigCloudUpdateStateChanged,
-               this, &UIMachineManagerWidget::sigCloudUpdateStateChanged);
-    disconnect(m_pPaneChooser, &UIChooser::sigToolMenuRequested,
-               this, &UIMachineManagerWidget::sltHandleToolMenuRequested);
-    disconnect(m_pPaneChooser, &UIChooser::sigCloudProfileStateChange,
-               this, &UIMachineManagerWidget::sigCloudProfileStateChange);
-    disconnect(m_pPaneChooser, &UIChooser::sigCloudMachineStateChange,
-               this, &UIMachineManagerWidget::sltHandleCloudMachineStateChange);
-    disconnect(m_pPaneChooser, &UIChooser::sigStartOrShowRequest,
-               this, &UIMachineManagerWidget::sigStartOrShowRequest);
-    disconnect(m_pPaneChooser, &UIChooser::sigMachineSearchWidgetVisibilityChanged,
-               this, &UIMachineManagerWidget::sigMachineSearchWidgetVisibilityChanged);
-
-    /* Details-pane connections: */
+
+    /* Tools-pane connections: */
     disconnect(m_pPaneTools, &UIToolPaneMachine::sigLinkClicked,
                this, &UIMachineManagerWidget::sigMachineSettingsLinkClicked);
 
-    /* Tools-pane connections: */
+    /* Tools-menu connections: */
     disconnect(m_pMenuTools, &UITools::sigSelectionChanged,
                this, &UIMachineManagerWidget::sltHandleToolsMenuIndexChange);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.h	(revision 107330)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.h	(revision 107331)
@@ -72,21 +72,7 @@
         /** Notifies about Chooser-pane selection change. */
         void sigChooserPaneSelectionChange();
-        /** Notifies about Chooser-pane group saving change. */
-        void sigGroupSavingStateChanged();
-        /** Notifies about Chooser-pane cloud update change. */
-        void sigCloudUpdateStateChanged();
-
-        /** Notifies listeners about cloud profile state change.
-          * @param  strProviderShortName  Brings the cloud provider short name.
-          * @param  strProfileName        Brings the cloud profile name. */
-        void sigCloudProfileStateChange(const QString &strProviderShortName,
-                                        const QString &strProfileName);
+
         /** Notifies about state change for cloud machine with certain @a uId. */
         void sigCloudMachineStateChange(const QUuid &uId);
-
-        /** Notify listeners about start or show request. */
-        void sigStartOrShowRequest();
-        /** Notifies listeners about machine search widget visibility changed to @a fVisible. */
-        void sigMachineSearchWidgetVisibilityChanged(bool fVisible);
     /** @} */
 
@@ -97,26 +83,8 @@
     /** @} */
 
-    /** @name Tools / Generic pane stuff.
-      * @{ */
-        /** Notifies listeners about request to detach pane with tool type @p enmToolType. */
-        void sigDetachToolPane(UIToolType enmToolType);
-    /** @} */
-
     /** @name Tools / Details pane stuff.
       * @{ */
         /** Notifies aboud Details-pane link clicked. */
         void sigMachineSettingsLinkClicked(const QString &strCategory, const QString &strControl, const QUuid &uId);
-    /** @} */
-
-    /** @name Tools / Snapshots pane stuff.
-      * @{ */
-        /** Notifies listeners about current Snapshots pane item change. */
-        void sigCurrentSnapshotItemChange();
-    /** @} */
-
-    /** @name Tools / VM Activity pane stuff.
-      * @{ */
-        /** Notifies listeners about request to switch to Activity Overview pane. */
-        void sigSwitchToActivityOverviewPane();
     /** @} */
 
@@ -214,4 +182,7 @@
         /** Closes pane tool of passed @a enmType. */
         void closeTool(UIToolType enmType);
+
+        /** Switches to VM Activity pane of machine with @a uMachineId. */
+        void switchToVMActivityPane(const QUuid &uMachineId);
     /** @} */
 
@@ -282,7 +253,4 @@
           * @param  enmType  Brings current tool type. */
         void sltHandleToolsMenuIndexChange(UIToolType enmType) { switchToolTo(enmType); }
-
-        /** Handles signal requesting switch to VM Activity pane of machine with @a uMachineId. */
-        void sltSwitchToVMActivityPane(const QUuid &uMachineId);
     /** @} */
 