Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsManagerWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsManagerWidget.h	(revision 107338)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsManagerWidget.h	(revision 107339)
@@ -167,7 +167,7 @@
     UIActionPool *m_pActionPool;
 
-    /** Holds the Global Tools-menu instance. */
+    /** Holds the Tools-menu instance. */
     UITools          *m_pMenu;
-    /** Holds the Global Tools-pane instance. */
+    /** Holds the Tools-pane instance. */
     UIToolPaneGlobal *m_pPane;
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.cpp	(revision 107338)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.cpp	(revision 107339)
@@ -66,9 +66,4 @@
 }
 
-void UIMachineManagerWidget::setActive(bool fActive)
-{
-    m_pPaneTools->setActive(fActive);
-}
-
 UIChooser *UIMachineManagerWidget::chooser() const
 {
@@ -78,10 +73,10 @@
 UIVirtualMachineItem *UIMachineManagerWidget::currentItem() const
 {
-    return m_pPaneChooser->currentItem();
+    return chooser()->currentItem();
 }
 
 QList<UIVirtualMachineItem*> UIMachineManagerWidget::currentItems() const
 {
-    return m_pPaneChooser->currentItems();
+    return chooser()->currentItems();
 }
 
@@ -95,45 +90,35 @@
 bool UIMachineManagerWidget::isGroupItemSelected() const
 {
-    return m_pPaneChooser->isGroupItemSelected();
+    return chooser()->isGroupItemSelected();
 }
 
 bool UIMachineManagerWidget::isMachineItemSelected() const
 {
-    return m_pPaneChooser->isMachineItemSelected();
+    return chooser()->isMachineItemSelected();
 }
 
 bool UIMachineManagerWidget::isLocalMachineItemSelected() const
 {
-    return m_pPaneChooser->isLocalMachineItemSelected();
+    return chooser()->isLocalMachineItemSelected();
 }
 
 bool UIMachineManagerWidget::isCloudMachineItemSelected() const
 {
-    return m_pPaneChooser->isCloudMachineItemSelected();
-}
-
-bool UIMachineManagerWidget::isSingleGroupSelected() const
-{
-    return m_pPaneChooser->isSingleGroupSelected();
+    return chooser()->isCloudMachineItemSelected();
 }
 
 bool UIMachineManagerWidget::isSingleLocalGroupSelected() const
 {
-    return m_pPaneChooser->isSingleLocalGroupSelected();
+    return chooser()->isSingleLocalGroupSelected();
 }
 
 bool UIMachineManagerWidget::isSingleCloudProviderGroupSelected() const
 {
-    return m_pPaneChooser->isSingleCloudProviderGroupSelected();
+    return chooser()->isSingleCloudProviderGroupSelected();
 }
 
 bool UIMachineManagerWidget::isSingleCloudProfileGroupSelected() const
 {
-    return m_pPaneChooser->isSingleCloudProfileGroupSelected();
-}
-
-bool UIMachineManagerWidget::isAllItemsOfOneGroupSelected() const
-{
-    return m_pPaneChooser->isAllItemsOfOneGroupSelected();
+    return chooser()->isSingleCloudProfileGroupSelected();
 }
 
@@ -151,64 +136,4 @@
 }
 
-QString UIMachineManagerWidget::fullGroupName() const
-{
-    return m_pPaneChooser->fullGroupName();
-}
-
-bool UIMachineManagerWidget::isGroupSavingInProgress() const
-{
-    return m_pPaneChooser->isGroupSavingInProgress();
-}
-
-bool UIMachineManagerWidget::isCloudProfileUpdateInProgress() const
-{
-    return m_pPaneChooser->isCloudProfileUpdateInProgress();
-}
-
-void UIMachineManagerWidget::openGroupNameEditor()
-{
-    m_pPaneChooser->openGroupNameEditor();
-}
-
-void UIMachineManagerWidget::disbandGroup()
-{
-    m_pPaneChooser->disbandGroup();
-}
-
-void UIMachineManagerWidget::removeMachine()
-{
-    m_pPaneChooser->removeMachine();
-}
-
-void UIMachineManagerWidget::moveMachineToGroup(const QString &strName /* = QString() */)
-{
-    m_pPaneChooser->moveMachineToGroup(strName);
-}
-
-QStringList UIMachineManagerWidget::possibleGroupsForMachineToMove(const QUuid &uId)
-{
-    return m_pPaneChooser->possibleGroupsForMachineToMove(uId);
-}
-
-QStringList UIMachineManagerWidget::possibleGroupsForGroupToMove(const QString &strFullName)
-{
-    return m_pPaneChooser->possibleGroupsForGroupToMove(strFullName);
-}
-
-void UIMachineManagerWidget::refreshMachine()
-{
-    m_pPaneChooser->refreshMachine();
-}
-
-void UIMachineManagerWidget::sortGroup()
-{
-    m_pPaneChooser->sortGroup();
-}
-
-void UIMachineManagerWidget::setMachineSearchWidgetVisibility(bool fVisible)
-{
-    m_pPaneChooser->setMachineSearchWidgetVisibility(fVisible);
-}
-
 UIToolPaneMachine *UIMachineManagerWidget::toolPane() const
 {
@@ -218,6 +143,6 @@
 UIToolType UIMachineManagerWidget::menuToolType() const
 {
-    AssertPtrReturn(m_pMenuTools, UIToolType_Invalid);
-    return m_pMenuTools->toolsType();
+    AssertPtrReturn(toolMenu(), UIToolType_Invalid);
+    return toolMenu()->toolsType();
 }
 
@@ -229,12 +154,12 @@
     AssertReturnVoid(UIToolStuff::isTypeOfClass(enmType, UIToolClass_Machine));
 
-    AssertPtrReturnVoid(m_pMenuTools);
-    m_pMenuTools->setToolsType(enmType);
+    AssertPtrReturnVoid(toolMenu());
+    toolMenu()->setToolsType(enmType);
 }
 
 UIToolType UIMachineManagerWidget::toolType() const
 {
-    AssertPtrReturn(m_pPaneTools, UIToolType_Invalid);
-    return m_pPaneTools->currentTool();
+    AssertPtrReturn(toolPane(), UIToolType_Invalid);
+    return toolPane()->currentTool();
 }
 
@@ -246,6 +171,6 @@
     AssertReturn(UIToolStuff::isTypeOfClass(enmType, UIToolClass_Machine), false);
 
-    AssertPtrReturn(m_pPaneTools, false);
-    return m_pPaneTools->isToolOpened(enmType);
+    AssertPtrReturn(toolPane(), false);
+    return toolPane()->isToolOpened(enmType);
 }
 
@@ -258,6 +183,6 @@
 
     /* Open corresponding tool: */
-    AssertPtrReturnVoid(m_pPaneTools);
-    m_pPaneTools->openTool(enmType);
+    AssertPtrReturnVoid(toolPane());
+    toolPane()->openTool(enmType);
 
     /* Let the parent know: */
@@ -272,24 +197,24 @@
     AssertReturnVoid(UIToolStuff::isTypeOfClass(enmType, UIToolClass_Machine));
 
-    AssertPtrReturnVoid(m_pPaneTools);
-    m_pPaneTools->closeTool(enmType);
+    AssertPtrReturnVoid(toolPane());
+    toolPane()->closeTool(enmType);
 }
 
 bool UIMachineManagerWidget::isCurrentStateItemSelected() const
 {
-    AssertPtrReturn(m_pPaneTools, false);
-    return m_pPaneTools->isCurrentStateItemSelected();
+    AssertPtrReturn(toolPane(), false);
+    return toolPane()->isCurrentStateItemSelected();
 }
 
 QUuid UIMachineManagerWidget::currentSnapshotId()
 {
-    AssertPtrReturn(m_pPaneTools, QUuid());
-    return m_pPaneTools->currentSnapshotId();
+    AssertPtrReturn(toolPane(), QUuid());
+    return toolPane()->currentSnapshotId();
 }
 
 QString UIMachineManagerWidget::currentHelpKeyword() const
 {
-    AssertPtrReturn(m_pPaneTools, QString());
-    return m_pPaneTools->currentHelpKeyword();
+    AssertPtrReturn(toolPane(), QString());
+    return toolPane()->currentHelpKeyword();
 }
 
@@ -404,6 +329,6 @@
     {
         /* If Error-pane is chosen currently => switch to tool currently chosen in Tools-menu: */
-        if (m_pPaneTools->currentTool() == UIToolType_Error)
-            switchToolTo(m_pMenuTools->toolsType());
+        if (toolPane()->currentTool() == UIToolType_Error)
+            switchToolTo(toolMenu()->toolsType());
 
         /* If we still have same item selected: */
@@ -411,5 +336,5 @@
         {
             /* Propagate current items to update the Details-pane: */
-            m_pPaneTools->setItems(currentItems());
+            toolPane()->setItems(currentItems());
         }
     }
@@ -417,6 +342,6 @@
     {
         /* Make sure Error pane raised: */
-        if (m_pPaneTools->currentTool() != UIToolType_Error)
-            m_pPaneTools->openTool(UIToolType_Error);
+        if (toolPane()->currentTool() != UIToolType_Error)
+            toolPane()->openTool(UIToolType_Error);
 
         /* If we still have same item selected: */
@@ -424,7 +349,7 @@
         {
             /* Propagate current items to update the Details-pane (in any case): */
-            m_pPaneTools->setItems(currentItems());
+            toolPane()->setItems(currentItems());
             /* Propagate last access error to update the Error-pane (if machine selected but inaccessible): */
-            m_pPaneTools->setErrorDetails(pItem->accessError());
+            toolPane()->setErrorDetails(pItem->accessError());
         }
     }
@@ -437,5 +362,5 @@
 {
     /* Update tools menu beforehand: */
-    UITools *pMenu = pItem ? m_pMenuTools : 0;
+    UITools *pMenu = pItem ? toolMenu() : 0;
     AssertPtrReturnVoid(pMenu);
     if (pItem)
@@ -464,8 +389,8 @@
 void UIMachineManagerWidget::sltSwitchToVMActivityPane(const QUuid &uMachineId)
 {
-    AssertPtrReturnVoid(m_pPaneChooser);
-    AssertPtrReturnVoid(m_pMenuTools);
-    m_pPaneChooser->setCurrentMachine(uMachineId);
-    m_pMenuTools->setToolsType(UIToolType_VMActivity);
+    AssertPtrReturnVoid(chooser());
+    AssertPtrReturnVoid(toolMenu());
+    chooser()->setCurrentMachine(uMachineId);
+    toolMenu()->setToolsType(UIToolType_VMActivity);
 }
 
@@ -504,19 +429,19 @@
             /* Create Chooser-pane: */
             m_pPaneChooser = new UIChooser(this, actionPool());
-            if (m_pPaneChooser)
+            if (chooser())
             {
                 /* Add into splitter: */
-                m_pSplitter->addWidget(m_pPaneChooser);
+                m_pSplitter->addWidget(chooser());
             }
 
             /* Create Tools-pane: */
             m_pPaneTools = new UIToolPaneMachine(actionPool());
-            if (m_pPaneTools)
+            if (toolPane())
             {
                 /// @todo make sure it's used properly
-                m_pPaneTools->setActive(true);
+                toolPane()->setActive(true);
 
                 /* Add into splitter: */
-                m_pSplitter->addWidget(m_pPaneTools);
+                m_pSplitter->addWidget(toolPane());
             }
 
@@ -534,5 +459,5 @@
 
     /* Bring the VM list to the focus: */
-    m_pPaneChooser->setFocus();
+    chooser()->setFocus();
 }
 
@@ -558,23 +483,23 @@
 
     /* Chooser-pane connections: */
-    connect(m_pPaneChooser, &UIChooser::sigSelectionChanged,
+    connect(chooser(), &UIChooser::sigSelectionChanged,
             this, &UIMachineManagerWidget::sltHandleChooserPaneIndexChange);
-    connect(m_pPaneChooser, &UIChooser::sigSelectionInvalidated,
+    connect(chooser(), &UIChooser::sigSelectionInvalidated,
             this, &UIMachineManagerWidget::sltHandleChooserPaneSelectionInvalidated);
-    connect(m_pPaneChooser, &UIChooser::sigToolMenuRequested,
+    connect(chooser(), &UIChooser::sigToolMenuRequested,
             this, &UIMachineManagerWidget::sltHandleToolMenuRequested);
-    connect(m_pPaneChooser, &UIChooser::sigCloudMachineStateChange,
+    connect(chooser(), &UIChooser::sigCloudMachineStateChange,
             this, &UIMachineManagerWidget::sltHandleCloudMachineStateChange);
-    connect(m_pPaneChooser, &UIChooser::sigToggleStarted,
-            m_pPaneTools, &UIToolPaneMachine::sigToggleStarted);
-    connect(m_pPaneChooser, &UIChooser::sigToggleFinished,
-            m_pPaneTools, &UIToolPaneMachine::sigToggleFinished);
+    connect(chooser(), &UIChooser::sigToggleStarted,
+            toolPane(), &UIToolPaneMachine::sigToggleStarted);
+    connect(chooser(), &UIChooser::sigToggleFinished,
+            toolPane(), &UIToolPaneMachine::sigToggleFinished);
 
     /* Tools-pane connections: */
-    connect(m_pPaneTools, &UIToolPaneMachine::sigLinkClicked,
+    connect(toolPane(), &UIToolPaneMachine::sigLinkClicked,
             this, &UIMachineManagerWidget::sigMachineSettingsLinkClicked);
 
     /* Tools-menu connections: */
-    connect(m_pMenuTools, &UITools::sigSelectionChanged,
+    connect(toolMenu(), &UITools::sigSelectionChanged,
             this, &UIMachineManagerWidget::sltHandleToolsMenuIndexChange);
 }
@@ -595,5 +520,5 @@
 
     /* Open tool last chosen in Tools-menu: */
-    switchToolTo(m_pMenuTools->toolsType());
+    switchToolTo(toolMenu()->toolsType());
 }
 
@@ -601,23 +526,23 @@
 {
     /* Chooser-pane connections: */
-    disconnect(m_pPaneChooser, &UIChooser::sigSelectionChanged,
+    disconnect(chooser(), &UIChooser::sigSelectionChanged,
                this, &UIMachineManagerWidget::sltHandleChooserPaneIndexChange);
-    disconnect(m_pPaneChooser, &UIChooser::sigSelectionInvalidated,
+    disconnect(chooser(), &UIChooser::sigSelectionInvalidated,
                this, &UIMachineManagerWidget::sltHandleChooserPaneSelectionInvalidated);
-    disconnect(m_pPaneChooser, &UIChooser::sigToolMenuRequested,
+    disconnect(chooser(), &UIChooser::sigToolMenuRequested,
                this, &UIMachineManagerWidget::sltHandleToolMenuRequested);
-    disconnect(m_pPaneChooser, &UIChooser::sigCloudMachineStateChange,
+    disconnect(chooser(), &UIChooser::sigCloudMachineStateChange,
                this, &UIMachineManagerWidget::sltHandleCloudMachineStateChange);
-    disconnect(m_pPaneChooser, &UIChooser::sigToggleStarted,
-               m_pPaneTools, &UIToolPaneMachine::sigToggleStarted);
-    disconnect(m_pPaneChooser, &UIChooser::sigToggleFinished,
-               m_pPaneTools, &UIToolPaneMachine::sigToggleFinished);
+    disconnect(chooser(), &UIChooser::sigToggleStarted,
+               toolPane(), &UIToolPaneMachine::sigToggleStarted);
+    disconnect(chooser(), &UIChooser::sigToggleFinished,
+               toolPane(), &UIToolPaneMachine::sigToggleFinished);
 
     /* Tools-pane connections: */
-    disconnect(m_pPaneTools, &UIToolPaneMachine::sigLinkClicked,
+    disconnect(toolPane(), &UIToolPaneMachine::sigLinkClicked,
                this, &UIMachineManagerWidget::sigMachineSettingsLinkClicked);
 
     /* Tools-menu connections: */
-    disconnect(m_pMenuTools, &UITools::sigSelectionChanged,
+    disconnect(toolMenu(), &UITools::sigSelectionChanged,
                this, &UIMachineManagerWidget::sltHandleToolsMenuIndexChange);
 }
@@ -627,4 +552,9 @@
     /* Ask sub-dialogs to commit data: */
     sltHandleCommitData();
+}
+
+UITools *UIMachineManagerWidget::toolMenu() const
+{
+    return m_pMenuTools;
 }
 
@@ -643,9 +573,9 @@
     {
         /* If Error-pane is chosen currently => switch to tool currently chosen in Tools-menu: */
-        if (m_pPaneTools->currentTool() == UIToolType_Error)
-            switchToolTo(m_pMenuTools->toolsType());
+        if (toolPane()->currentTool() == UIToolType_Error)
+            switchToolTo(toolMenu()->toolsType());
 
         /* Propagate current items to the Tools pane: */
-        m_pPaneTools->setItems(currentItems());
+        toolPane()->setItems(currentItems());
     }
     /* Otherwise if we were not asked separately to calm down: */
@@ -653,10 +583,10 @@
     {
         /* Make sure Error pane raised: */
-        if (m_pPaneTools->currentTool() != UIToolType_Error)
-            m_pPaneTools->openTool(UIToolType_Error);
+        if (toolPane()->currentTool() != UIToolType_Error)
+            toolPane()->openTool(UIToolType_Error);
 
         /* Propagate last access error to the Error-pane: */
         if (pItem)
-            m_pPaneTools->setErrorDetails(pItem->accessError());
+            toolPane()->setErrorDetails(pItem->accessError());
     }
 }
@@ -676,13 +606,13 @@
                         << UIToolType_Logs
                         << UIToolType_FileManager;
-    if (restrictedTypes.contains(m_pMenuTools->toolsType()))
-        m_pMenuTools->setToolsType(UIToolType_Details);
+    if (restrictedTypes.contains(toolMenu()->toolsType()))
+        toolMenu()->setToolsType(UIToolType_Details);
     const QList restrictions(restrictedTypes.begin(), restrictedTypes.end());
-    m_pMenuTools->setRestrictedToolTypes(restrictions);
+    toolMenu()->setRestrictedToolTypes(restrictions);
     /* Update machine menu items availability: */
-    m_pMenuTools->setItemsEnabled(fCurrentItemIsOk);
+    toolMenu()->setItemsEnabled(fCurrentItemIsOk);
 
     /* Take restrictions into account, closing all restricted tools: */
     foreach (const UIToolType &enmRestrictedType, restrictedTypes)
-        m_pPaneTools->closeTool(enmRestrictedType);
-}
+        toolPane()->closeTool(enmRestrictedType);
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.h	(revision 107338)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineManagerWidget.h	(revision 107339)
@@ -101,7 +101,4 @@
         /** Returns the action-pool reference. */
         UIActionPool *actionPool() const { return m_pActionPool; }
-
-        /** Makes manager active. */
-        void setActive(bool fActive);
     /** @} */
 
@@ -128,6 +125,4 @@
         bool isCloudMachineItemSelected() const;
 
-        /** Returns whether single group is selected. */
-        bool isSingleGroupSelected() const;
         /** Returns whether single local group is selected. */
         bool isSingleLocalGroupSelected() const;
@@ -136,36 +131,7 @@
         /** Returns whether single cloud profile group is selected. */
         bool isSingleCloudProfileGroupSelected() const;
-        /** Returns whether all items of one group are selected. */
-        bool isAllItemsOfOneGroupSelected() const;
 
         /** Returns current selection type. */
         SelectionType selectionType() const;
-
-        /** Returns full name of currently selected group. */
-        QString fullGroupName() const;
-
-        /** Returns whether group saving is in progress. */
-        bool isGroupSavingInProgress() const;
-        /** Returns whether at least one cloud profile currently being updated. */
-        bool isCloudProfileUpdateInProgress() const;
-
-        /** Opens group name editor. */
-        void openGroupNameEditor();
-        /** Disbands group. */
-        void disbandGroup();
-        /** Removes machine. */
-        void removeMachine();
-        /** Moves machine to a group with certain @a strName. */
-        void moveMachineToGroup(const QString &strName = QString());
-        /** Returns possible groups for machine with passed @a uId to move to. */
-        QStringList possibleGroupsForMachineToMove(const QUuid &uId);
-        /** Returns possible groups for group with passed @a strFullName to move to. */
-        QStringList possibleGroupsForGroupToMove(const QString &strFullName);
-        /** Refreshes machine. */
-        void refreshMachine();
-        /** Sorts group. */
-        void sortGroup();
-        /** Toggle machine search widget to be @a fVisible. */
-        void setMachineSearchWidgetVisibility(bool fVisible);
     /** @} */
 
@@ -282,4 +248,7 @@
     /** @name Tools stuff.
       * @{ */
+        /** Returns tool-menu instance. */
+        UITools *toolMenu() const;
+
         /** Recaches current machine item information.
           * @param  fDontRaiseErrorPane  Brings whether we should not raise error-pane. */