Index: trunk/src/VBox/Main/Makefile.kmk
===================================================================
--- trunk/src/VBox/Main/Makefile.kmk	(revision 107345)
+++ trunk/src/VBox/Main/Makefile.kmk	(revision 107362)
@@ -1535,9 +1535,4 @@
  # Experimental COM proxy + stub DLL w/ automatic registration updating.
  #
- # The Legacy stub is for older 64-bit windows versions (pre Windows 7) as we
- # were having various problems on windows server 2003 and 2008 with the code
- # MIDL generated.  Also, in windows 7 there are some potentially interesting
- # changes in the generated code where it uses new helpers from OLE32.
- #
  DLLS += VBoxProxyStub
  VBoxProxyStub_TEMPLATE = VBoxMainComp
@@ -1566,19 +1561,4 @@
  src-all/win/VBoxProxyStub.rc_DEPS = $(VBoxCOM_0_OUTDIR)/VirtualBox.tlb
  VBoxProxyStub_VirtualBox_p.c_CFLAGS.x86 = /Gz # Workaround for incorrect ObjectStublessClient* prototypes in SDK v7.1.
-
- ifn1of ($(KBUILD_TARGET_ARCH), arm64)
-  DLLS += VBoxProxyStubLegacy
-  VBoxProxyStubLegacy_TEMPLATE = VBoxMainComp
-  VBoxProxyStubLegacy_EXTENDS  = VBoxProxyStub
-  VBoxProxyStubLegacy_DEFS     = $(VBoxProxyStub_DEFS) VBOX_IN_PROXY_STUB_LEGACY
-  VBoxProxyStubLegacy_INCS     = $(VBoxCOM_0_OUTDIR)/legacy/
-  VBoxProxyStubLegacy_SOURCES  = \
-  	$(VBoxCOM_0_OUTDIR)/legacy/VirtualBox_p.c \
-  	$(VBoxCOM_0_OUTDIR)/legacy/VirtualBox_i.c \
-  	src-all/win/VBoxProxyStub.def \
-  	src-all/win/VBoxProxyStubLegacy.rc \
-  	src-all/win/VBoxProxyStub.c
-  src-all/win/VBoxProxyStubLegacy.rc_DEPS = $(VBoxCOM_0_OUTDIR)/legacy/VirtualBox.tlb
- endif
 
  ifdef VBOX_WITH_32_ON_64_MAIN_API
@@ -1765,6 +1745,5 @@
 
  if defined(VBOX_WITH_32_ON_64_MAIN_API) && !defined(VBOX_ONLY_EXTPACKS)
-  # The XP targetted 32-bit proxy stub works with all versions of windows (the
-  # issues leading to the VBoxProxyStubLegacy.dll are only on 64-bit windows).
+  # The XP targetted 32-bit proxy stub works with all versions of windows.
   $(call KB_FN_AUTO_CMD_DEPS,$(VBoxCOM-x86_0_OUTDIR)/VirtualBox_i.c)
   $(VBoxCOM-x86_0_OUTDIR)/VirtualBox_i.c \
Index: trunk/src/VBox/Main/glue/initterm.cpp
===================================================================
--- trunk/src/VBox/Main/glue/initterm.cpp	(revision 107345)
+++ trunk/src/VBox/Main/glue/initterm.cpp	(revision 107362)
@@ -466,9 +466,5 @@
             if (RT_SUCCESS(vrc))
 #  ifndef VBOX_IN_32_ON_64_MAIN_API
-                vrc = RTPathAppend(szPath, sizeof(szPath),
-                                      RT_MAKE_U64(((PKUSER_SHARED_DATA)MM_SHARED_USER_DATA_VA)->NtMinorVersion,
-                                                  ((PKUSER_SHARED_DATA)MM_SHARED_USER_DATA_VA)->NtMajorVersion)
-                                   >= RT_MAKE_U64(1/*Lo*/,6/*Hi*/)
-                                   ? "VBoxProxyStub.dll" : "VBoxProxyStubLegacy.dll");
+                vrc = RTPathAppend(szPath, sizeof(szPath), "VBoxProxyStub.dll");
 #  else
                 vrc = RTPathAppend(szPath, sizeof(szPath), "x86\\VBoxProxyStub-x86.dll");
Index: trunk/src/VBox/Main/src-all/win/VBoxProxyStub.c
===================================================================
--- trunk/src/VBox/Main/src-all/win/VBoxProxyStub.c	(revision 107345)
+++ trunk/src/VBox/Main/src-all/win/VBoxProxyStub.c	(revision 107362)
@@ -91,7 +91,5 @@
  * Selects the proxy stub DLL based on 32-on-64-bit and host OS version.
  *
- * The legacy DLL covers 64-bit pre Windows 7 versions of Windows. W2K3-amd64
- * has trouble parsing the result when MIDL /target NT51 or higher. Vista and
- * windows server 2008 seems to have trouble with newer IDL compilers.
+ * Note! We used to have a separate version of the 64-bit DLL for pre-win7.
  */
 #if ARCH_BITS == 64 || defined(VBOX_IN_32_ON_64_MAIN_API)
@@ -100,8 +98,5 @@
 # define VBPS_PROXY_STUB_FILE(a_fIs32On64) VBPS_PROXY_STUB_FILE_SUB()
 #endif
-#define VBPS_PROXY_STUB_FILE_SUB() \
-    ( RT_MAKE_U64(((PKUSER_SHARED_DATA)MM_SHARED_USER_DATA_VA)->NtMinorVersion, \
-                  ((PKUSER_SHARED_DATA)MM_SHARED_USER_DATA_VA)->NtMajorVersion) >= RT_MAKE_U64(1/*Lo*/,6/*Hi*/) \
-      ? "VBoxProxyStub.dll" : "VBoxProxyStubLegacy.dll" )
+#define VBPS_PROXY_STUB_FILE_SUB()         "VBoxProxyStub.dll"
 
 /** For use with AssertLogRel except a_Expr1 from assertions but not LogRel. */
Index: trunk/src/VBox/Main/src-all/win/VBoxProxyStubLegacy.rc
===================================================================
--- trunk/src/VBox/Main/src-all/win/VBoxProxyStubLegacy.rc	(revision 107345)
+++ 	(revision )
@@ -1,34 +1,0 @@
-/* $Id$ */
-/** @file
- * VBoxProxyStub - Resource file containing version info, icon and typelib.
- */
-
-/*
- * Copyright (C) 2006-2024 Oracle and/or its affiliates.
- *
- * This file is part of VirtualBox base platform packages, as
- * available from https://www.virtualbox.org.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License
- * as published by the Free Software Foundation, in version 3 of the
- * License.
- *
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, see <https://www.gnu.org/licenses>.
- *
- * SPDX-License-Identifier: GPL-3.0-only
- */
-
-#define IN_FILE_DESCRIPTION "VirtualBox COM Proxy Stub and Type Library (pre Windows 7)"
-#define IN_FILE_BASENAME    "VBoxProxyStubLegacy"
-
-#include "../../../Artwork/win/TemplateDll.rc"
-
-1 TYPELIB "VirtualBox.tlb"
-
Index: trunk/src/VBox/Main/src-all/win/comregister.cmd
===================================================================
--- trunk/src/VBox/Main/src-all/win/comregister.cmd	(revision 107345)
+++ trunk/src/VBox/Main/src-all/win/comregister.cmd	(revision 107362)
@@ -113,19 +113,4 @@
 
 REM
-REM Figure out the Windows version as the proxy stub requires 6.0 or later (at least for 64-bit).
-REM
-set WinVer=Version 4.0.1381
-set WinVerMajor=4
-set WinVerMinor=0
-set WinVerBuild=1381
-for /f "tokens=2 delims=[]" %%a in ('ver') do set WinVer=%%a
-for /f "tokens=2,3,4 delims=. " %%a in ("%WinVer%") do (
-    set WinVerMajor=%%a
-    set WinVerMinor=%%b
-    set WinVerBuild=%%c
-)
-REM echo WinVerMajor=%WinVerMajor% WinVerMinor=%WinVerMinor% WinVerBuild=%WinVerBuild%  WinVer=%WinVer%
-
-REM
 REM Parse arguments.
 REM
@@ -182,14 +167,4 @@
 REM Unregister all first, then register them. The order matters here.
 :register_amd64
-if "%WinVerMajor%" == "5" goto register_amd64_legacy
-if not "%WinVerMajor%" == "6" goto register_amd64_not_legacy
-if not "%WinVerMinor%" == "0" goto register_amd64_not_legacy
-:register_amd64_legacy
-set s64BitProxyStub=VBoxProxyStubLegacy.dll
-goto register_amd64_begin
-:register_amd64_not_legacy
-set s64BitProxyStub=VBoxProxyStub.dll
-:register_amd64_begin
-echo s64BitProxyStub=%s64BitProxyStub%
 @echo on
 "%_VBOX_DIR%VBoxSVC.exe" /UnregServer
@@ -197,5 +172,5 @@
 %windir%\system32\regsvr32 /s /u "%_VBOX_DIR%VBoxC.dll"
 %windir%\syswow64\regsvr32 /s /u "%_VBOX_DIR%x86\VBoxClient-x86.dll"
-%windir%\system32\regsvr32 /s /u "%_VBOX_DIR%%s64BitProxyStub%"
+%windir%\system32\regsvr32 /s /u "%_VBOX_DIR%VBoxProxyStub.dll"
 %windir%\syswow64\regsvr32 /s /u "%_VBOX_DIR%x86\VBoxProxyStub-x86.dll"
 if %fUninstallOnly% == 1 goto end
@@ -205,5 +180,5 @@
 %windir%\syswow64\regsvr32 /s    "%_VBOX_DIR%x86\VBoxClient-x86.dll"
 if %fNoProxy% == 1 goto end
-if exist "%_VBOX_DIR%%s64BitProxyStub%"         %windir%\system32\regsvr32 /s "%_VBOX_DIR%%s64BitProxyStub%"
+if exist "%_VBOX_DIR%VBoxProxyStub.dll"         %windir%\system32\regsvr32 /s "%_VBOX_DIR%VBoxProxyStub.dll"
 if exist "%_VBOX_DIR%x86\VBoxProxyStub-x86.dll" %windir%\syswow64\regsvr32 /s "%_VBOX_DIR%x86\VBoxProxyStub-x86.dll"
 @echo off