Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 107420)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 107421)
@@ -1189,6 +1189,6 @@
     QPixmap pixmapMask = uimachine()->cursorMaskPixmap();
     const QPoint hotspot = uimachine()->cursorHotspot();
-    uint uXHot = hotspot.x();
-    uint uYHot = hotspot.y();
+    int iXHot = hotspot.x();
+    int iYHot = hotspot.y();
 
     /* If there is no mask: */
@@ -1197,6 +1197,6 @@
         /* Scale the shape pixmap and
          * compose the cursor on the basis of shape only: */
-        updateMousePointerPixmapScaling(pixmapShape, uXHot, uYHot);
-        m_cursor = QCursor(pixmapShape, uXHot, uYHot);
+        updateMousePointerPixmapScaling(pixmapShape, iXHot, iYHot);
+        m_cursor = QCursor(pixmapShape, iXHot, iYHot);
     }
     /* Otherwise: */
@@ -1205,7 +1205,7 @@
         /* Scale the shape and the mask pixmaps and
          * compose the cursor on the basis of shape and mask both: */
-        updateMousePointerPixmapScaling(pixmapShape, uXHot, uYHot);
-        /// @todo updateMousePointerPixmapScaling(pixmapMask, uXHot, uYHot);
-        m_cursor = QCursor(QBitmap::fromPixmap(pixmapShape), QBitmap::fromPixmap(pixmapMask), uXHot, uYHot);
+        updateMousePointerPixmapScaling(pixmapShape, iXHot, iYHot);
+        /// @todo updateMousePointerPixmapScaling(pixmapMask, iXHot, iYHot);
+        m_cursor = QCursor(QBitmap::fromPixmap(pixmapShape), QBitmap::fromPixmap(pixmapMask), iXHot, iYHot);
     }
 
@@ -2196,5 +2196,5 @@
 }
 
-void UIMachineView::updateMousePointerPixmapScaling(QPixmap &pixmap, uint &uXHot, uint &uYHot)
+void UIMachineView::updateMousePointerPixmapScaling(QPixmap &pixmap, int &iXHot, int &iYHot)
 {
 #if defined(VBOX_WS_MAC)
@@ -2208,6 +2208,6 @@
         pixmap = pixmap.scaled(pixmap.width() * dScaleFactor, pixmap.height() * dScaleFactor,
                                Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
-        uXHot *= dScaleFactor;
-        uYHot *= dScaleFactor;
+        iXHot *= dScaleFactor;
+        iYHot *= dScaleFactor;
     }
 
@@ -2221,6 +2221,6 @@
         /* Scale the pixmap down: */
         pixmap.setDevicePixelRatio(dDevicePixelRatio);
-        uXHot /= dDevicePixelRatio;
-        uYHot /= dDevicePixelRatio;
+        iXHot /= dDevicePixelRatio;
+        iYHot /= dDevicePixelRatio;
     }
 
@@ -2253,6 +2253,6 @@
         pixmap = pixmap.scaled(pixmap.width() * dScaleMultiplier, pixmap.height() * dScaleMultiplier,
                                Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
-        uXHot *= dScaleMultiplier;
-        uYHot *= dScaleMultiplier;
+        iXHot *= dScaleMultiplier;
+        iYHot *= dScaleMultiplier;
     }
 
@@ -2263,6 +2263,6 @@
         /* Scale the pixmap down: */
         pixmap.setDevicePixelRatio(dDevicePixelRatio);
-        uXHot /= dDevicePixelRatio;
-        uYHot /= dDevicePixelRatio;
+        iXHot /= dDevicePixelRatio;
+        iYHot /= dDevicePixelRatio;
     }
 # endif
@@ -2271,6 +2271,6 @@
 
     Q_UNUSED(pixmap);
-    Q_UNUSED(uXHot);
-    Q_UNUSED(uYHot);
+    Q_UNUSED(iXHot);
+    Q_UNUSED(iYHot);
 
 #endif
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h	(revision 107420)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h	(revision 107421)
@@ -383,6 +383,6 @@
     QSize scaledBackward(QSize size) const;
 
-    /** Updates mouse pointer @a pixmap, @a uXHot and @a uYHot according to scaling attributes. */
-    void updateMousePointerPixmapScaling(QPixmap &pixmap, uint &uXHot, uint &uYHot);
+    /** Updates mouse pointer @a pixmap, @a iXHot and @a iYHot according to scaling attributes. */
+    void updateMousePointerPixmapScaling(QPixmap &pixmap, int &iXHot, int &iYHot);
 
     /* Protected members: */